/* Erzeuger-Verbraucher-Kommunikation mittels Pipes */
#include <stdio.h>
#include <unistd.h>

void erzeuger(int filedes)	  /* "produziert" Buchstaben		*/
{
   char c;

   while (1) {
      c=getchar();		/* ein Zeichen von der Tastatur lesen	*/
      write(filedes,&c,1);	/* an den Verbraucher schicken		*/
      }
}


void verbraucher(int filedes)	/* "verbraucht" Buchstaben		*/
{
   char c;

   while (1) {
      read(filedes,&c,1);
      putchar(c);
      }
}


void main(int argc, char *argv[])
{
   int	fd[2];			/* Filedeskriptoren fuer die Pipe	*/
   int	child;			/* Child-PID				*/
   	
   
   pipe(fd);			/* Pipe erzeugen			*/
   child=fork();		/* Sohnprozess starten 			*/
   if (child==0)		/* Bin ich der Sohnprozess? 		*/
      erzeuger(fd[1]);		/* Erzeuger: fd[1] ist der Identifier 	*/
   else				/* zum Schreiben in die Pipe		*/
      verbraucher(fd[0]);	/* Verbraucher: fd[0] ist der Identifier*/
}				/* zum Lesen aus der Pipe		*/



